﻿/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Entity;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI;
using FogCreek.FogBugz.Database;

namespace IPluginFilterView_Example
{
    /* Class Declaration: Inherit from Plugin, expose IPluginFilterView */
    public class IPluginFilterView_Example : Plugin, IPluginFilterView
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginFilterView_Example(CPluginApi api)
            : base(api)
        {
        }

        #region IPluginFilterView Members

        public string PresentFilter(CFilter filter)
        {
            StringBuilder sb = new StringBuilder();
            CSelectQuery q = filter.GetBugsQuery(false, true, false);
            q.IgnorePermissions = true;
            System.Data.DataSet data = q.GetDataSet();
            foreach (System.Data.DataRow row in data.Tables["Bug"].Rows)
            {
                sb.Append(System.Web.HttpUtility.HtmlEncode(row["sTitle"].ToString()) + "<br />"); 
            }
            return sb.ToString();
        }

        public CViewMenuItem[] ViewMenuItems()
        {
            string sImgUrl = api.Url.PluginStaticFileUrl("IPluginFilterView_Example@fogcreek.com", "kiwi.png");
            return new CViewMenuItem[] {new CViewMenuItem(
                "Titles",
                "Display the case titles of all cases in the filter.",
                ViewMenuCategory.CaseList,
                "Case Titles Only",
                sImgUrl,
                sImgUrl)};
        }

        #endregion
    } 
}

